/***************************************************************************
      alt-main.c   -  Alternate non-gui version of Nnw
      project      -  Nnw
      version      -   .03
      -------------------
     date         : Fri August 17 2001
     copyright    : (C) 2001 Charles Baker
     email        : telegramsam_la@yahoo.com
****************************************************************************
****************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

#include <ctype.h>
#include "nnw.h"

int disp_menu(char *menu1[]);
void get_sel();
void clear_stdin();

int main(int argc, char *argv[]) {
    for(;;) {
	get_sel();
    }
}

// Check the users selection:
void get_sel() {

    char ch;
    int errc;
    char *menu1[] = { "L - Learn",
	"N - Dorm1 (light sleep)",
	"S - Dorm2 (deep sleep)",
	"C - Cleanup",
	"Q - Quit",
	NULL };

	ch = disp_menu(menu1);

	switch(ch) {
	    case 'L':
		if ((errc = nnwcv(def_snnslet, def_nnlet))) {
		    printf("alt-main.c: call to nnwcv() from get_sel() failed with errorcode %d\n",errc);
		    break;
		}
		if ((errc = nnwshop(def_nnlet, def_nn))) {
		    printf("alt-main.c: call to nnwshop() from get_sel() failed with errorcode %d\n",errc);
		}
		break;
	    case 'N':
		if ((errc = nnwdorm1(def_nn, def_nn))) {
		    printf("alt-main.c: call to nnwdorm1() from get_sel() failed with errorcode %d\n",errc);
		}
		break;
	    case 'S':
		if ((errc = nnwdorm1(def_nn, def_nn))) {
		    printf("alt-main.c: call to nnwdorm1() from get_sel() failed with errorcode %d\n",errc);
		    break;
		}
		if ((errc = nnwdorm2(def_nn, def_nn))) {
		    printf("alt-main.c: call to nnwdorm2() from get_sel() failed with errorcode %d\n",errc);
		}
		break;
	    case 'C':
		if ((errc = unlink(def_nn))) {
		    printf("alt-main.c: unlink from get_sel() failed with errorcode %d\n",errc);
		} else {
		    printf("Cleaned up\n");
		}
		break;
	    case 'Q':
		exit(0);
	} 
}

// Display the menu and get the selection from the user:
int disp_menu(char *menu1[]) {

    int c = 0; 
    char sel;
    char **opt;

    do {
	opt = menu1;

	while(*opt) {
	    printf("%s\n", *opt);
	    opt++;
	}
	printf("Please select from the above choices: ");
	clear_stdin();
	sel = toupper(getchar());
	opt = menu1;
	while(*opt) {
	    if(sel == *opt[0]) {
		c = 1;
		break;
	    }
	    opt++;
	}
    } while(!c);
    return sel;
}

// Clears stdin for your sanity ;-)
void clear_stdin() {
    freopen("/dev/tty", "r", stdin);
}
