/***************************************************************************
    nncv.c    -  convert SNNS-character file to input for demo 1
    project   -  Neu (neural) Net Work
    version   -   .03
    -------------------
     begin      : Tue Mar 21 2000
     copyright  : (C) 2001 by Ed van der Meulen
     email      : ameulen@users.sourceforge.net
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//-------------------- turns SNNS bit-input into NN input -----------------

//--------- all bits of one character and its answer is turned into one line
// input lines can be 0 1 1 0, 1 -2 5 0 1 or 0 -1 -2 2 1 0, these lines have
// only bits for positions, the negativs are flags and numbers after flags
// are for other purposes than for positions
// if a position digit is higher than a bit 0 or 1, the highest digit will be
// searched en the whole translation starts again

#include "nnw.h"

int nnwcv(char *fin, char *fon)
{
    int io[100];
    char name[] = "nnwcv";
    int ct = 0, tio;   // changed these to local vars
    char txt[256], *q, flogn[256], well[256];
		       // changed these to local too...
    int tt;            // free loopcounter
    int xt;            // horizontal pixelcounter
    int gb;            // groop basis of one number area, representing image position
    int gs = 2;        // size of number area, groop size, groop number space, bits:2
    int mint = 1;      // maximum integer, gs must > mint
    int mihi;          // logical: bit higher than mint
    int linmint = 0;   // mint of one line
    int linmihi;       // mihi og one line
    int flag;          // logical: former number was negativ
    int laplu;         // last normal positive number (plus)

    FILE *fi, *fo, *flog; // file stuff to get moved out of here eventually

    if ((fi = fopen (fin, "r")) == NULL)
    {   
	printf("nnwcv.c: error opening file %s\n",fin);
	return 1;
    }
    if ((fo = fopen (fon, "w")) == NULL)
    {
	printf("nnwcv.c: error opening file %s\n",fon);
	return 1;
    }

    strcpy (flogn, name); // log-file name = proc_name.log
    strcat (flogn, ".log");
    if ((flog = fopen (flogn, "w")) == NULL)
    {
	printf("nnwcv.c: error opening file %s\n",flogn);
	return 1;
    }

    strcpy (well, "SNNS-characters");
    do
    {
	mihi = 0;         // found that numbers are higher than mint (2)
	do                // n images to learn
	{
	    gb = -2;      // lowerbound starts for each character in 0
	    tio = 0;      // tio counts the digits of a character picture
	    laplu = 0;    // no last positiv number yet
	    linmihi = 0;  // in this line not yet a number > mint
	    ct++;         // ct counts (tels) characters NN will learn
	    flag = 0;     // no former negativ number, flag for next number
	    while (fgets (txt, 255, fi))   // -n lines te read per image
	    {
		xt = 0;   // xt counts the pos numbs, on a line
		if ((q = strchr (txt, '\n')) != NULL)
		    *q = '\0';
		q = strtok (txt, " "); 
		while (q)
		{
		    tio++;
		    io[tio] = atol(q);
		    if (io[tio] < 0)
			flag = 1;      // flag = 1 if former digit < 0
		    else if (flag)
			flag = 0;
		    else
		    {
			if (io[tio] > mint)   // other stuff, not bits
			{
			    linmint = io[tio];// search highest mint and start again
			    linmihi = 1;// mihi remembers other stuff
			}
			xt++;          // the number was positiv, one extra + number
			if (!mihi)     // here is io[tio] normal: positiv and < mint
			{
			    gb += gs;  // together with the digit: position + value 
			    io[tio] += gb; // gb denotes the position in the image
			    laplu = tio;   // last postive number (plus) so far
			}
			q = strtok (NULL, " ");
		    }
		}                      // ........   next digit of a line
		if (xt < 3)
		{
		    break;             // if only 1 or 2 + numbs this' an answer line
		}
		if (linmihi)
		{
		    mihi = 1;
		    mint = linmint;
		    linmihi = 0;
		}
	    }                          // next line

	    if (!mihi)
	    {
		io[laplu] -= gb;       // answer has no position in the image
		if (ct == 1)
		    fprintf (fo, "%i %i %s\n", gs, ct, well); // admin line
		for (tt = 1; tt <= tio; tt++)
		    fprintf (fo, "%i ", io[tt]);              // write inefficient
		fprintf (fo, "\n");    // close line
	    }
	}
	while (!feof (fi));
	if (mihi)                      // was mint = 2 too low
	{
	    fclose (fi);               // rewind and start with a higher gs
	    if ((fi = fopen (fin, "r")) == NULL)
	    {
		printf("nnwcv.c: error opening file %s\n",fin);
		return 1;
	    }
	    if (ct > 1)
	    {                          // written in fo
		fclose (fo);           // if written in fo than rewind fo
		if ((fo = fopen (fon, "w")) == NULL)
		{
		    printf("nnwcv.c: error opening file %s\n",fon);
		    return 1;
		}
	    }
	    while ((gs <<= 1) <= mint);// gs is the power of 2 above the actual mint
	    fgets (txt, 255, fi);      // skip the admin line this 2d time, is there one?
	    ct = 0;
	}
    }
    while (mihi);                      // start again
    fclose (fi);
    fclose (fo);
    return EXIT_SUCCESS;
}
