/***************************************************************************
     nnwdorm1.c  - dooze a little
     project      - Nnw
     version      -  .03
     -------------------
    begin     : Tue Mar 21 2000
    copyright : (C) 2001 by Ed van der Meulen
    email     : ameulen@users.sourceforge.net
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *    This program is free software; you can redistribute it and/or modify *
 *    it under the terms of the GNU General Public License as published by *
 *    the Free Software Foundation; either version 2 of the License, or    *
 *    (at your option) any later version.                                  *
 *                                                                         *
 ***************************************************************************/

/*  Dorm1 is a function of sleeping. It's a form of doozing, a light sleep.*
 *  Dorm1 forgets all things that he heard only one time. Repetition was   *
 *  necessary with yes and no. The strange thing this means that all cells *
 *  with no extra info are forgotten. That are cells saying go on this way *
 *  and nothing more. In contrast with other functions of sleep Dorm1 is   *
 *  not working bottom up. In fact only cells with no sisters are skipped. *
 *  Dorm1 was an easy programming task. Remind only your relatives.        *
 ***************************************************************************/

/* so the idea of dorm 1 is easy, skip all cells that are                  *
 * 1. no Alma                                                              *
 * 2. no answer cell                                                       * 
 * 3. no cell with a sister                                                *
 * this means all branches that have no side branches but are straight     *
 * lines are skipped The prgram has a lenght cause we cause we have to keep*
 * the connections (pointers) viable.                                      *
 * The motivation is simple. A cell only get's weight by a successful try  *
 * AND an unsuccessful try                                                 *
 ***************************************************************************/
#include "nnw.h"

int nnwdorm1(char *fin, char *fnnn)
{
    char name[] = "nnwdorm1", flogn[20], *q, well[256];
    int vc;                           // former celnr
    int nc;                           // new celnr
    int nc2;                          // 2d new celnr
    int ft = 0, ct;		      // the 3 date fields, dat1 is net's birthday
    long dat = 0, dat1, dat2, dat3;   // dat3 becomes new dat2, new dat3 
    int hor, ver;                     // size of input screen, only tranferred
    FILE *flog, *fi, *fnn;

    if ((fi = fopen (fin, "r")) == NULL)
    {
	printf("nnwdorm1.c: error opening file %s\n",fin);
	return 1;
    }
    if ((fnn = fopen (fnnn, "r")) == NULL)
    {
	printf("nnwdorm1.c: error opening file %s\n",fnnn);
	return 1;
    }

    strcpy (flogn, name);
    strcat (flogn, ".log");
    if ((flog = fopen (flogn, "w")) == NULL)
    {
	printf("nnwdorm1.c: error opening file %s\n",flogn);
	return 1;
    }
    fscanf (fi, "%li %li %li %i %i", &dat1, &dat2, &dat3, &hor, &ver);
    fgets (well, 255, fi);            // admin line of NN
    if ((q = strchr (well, '\n')) != NULL)
	*q = '\0';                    // remove trailling \n
    if (strstr ("slept", well) > 0)
    {
	printf ("I have slept earlier.\n");
	return 1;
    }
    ver = 0;
    ct = 0;
    while (!feof (fi))
    {                                 // read all cels of NN
	fscanf (fi, "%i %i %i %i %i %i %i %i %i %i", &cel[ct].ad, &cel[ct].me,
		&cel[ct].wei, &cel[ct].bi, &cel[ct].mot, &cel[ct].sis,
		&cel[ct].dot, &cel[ct].nan, &cel[ct].ans, &cel[ct].mar);
	ct++;			      // read per cell
    }
    ct -= 2;
    vc = 1;
    nc = 1;                           // alma vc=0 stays, the answer cell stays too
    fclose (fi);                      // and also daughters with a sister stay
    //------------go through the net, meeting all branches and shift the cells------//
    while (((cel[vc].sis != vc) || (cel[vc].dot == 0)) && (vc <= ct))
	vc++;
    if (vc > ct)                      // all the rest we skip and the tail shifts forward
    {
	printf ("I am now not sleepy, I want to stay awake.\n");
	return 0;                     // no answercel, NN broken, nothing to do
    }
    nc = vc + 1;                      // next can be my sister
    while (nc <= ct)
    {                                 // look for first cel with sister or answer
	while ((cel[nc].sis == nc) && (cel[nc].dot != 0) && (nc <= ct))
	    nc++;
	if (nc > ct)
	    break;                    // no more cels with sisses, okay, ready
	cel[vc].ad = cel[nc].ad;      // shift so copy cel with sis, only
	cel[vc].wei = cel[nc].wei;    // value fields, not pointer fields
	cel[vc].bi = cel[nc].bi;
	cel[vc].nan = cel[nc].nan;
	cel[vc].ans = cel[nc].ans;
	cel[vc].mar = cel[nc].mar;    // the rest is for keeping the relationships
				      // so the pointers
	if (cel[nc].sis == nc)
	{
	    cel[vc].sis = vc;         // oh my sister, begin with hers
	    cel[vc].dot = 0;          // no sis, sis is her own nc, if answer
	}                             // dot normal is next, ans has no daughters
	else
	{
	    cel[vc].sis = cel[nc].sis;// sisters yes, sis has not yet moved
	    nc2 = cel[nc].sis;        // find for nc her latest sis
	    while (cel[nc2].sis != nc)// if 1 sis then found
	    {
		nc2 = cel[nc2].sis;   // aparently a long circle of sisters
		if (nc2 == cel[nc2].sis)
		{
		    printf ("%ie False sister! nc: %i nc2: %i\n", ft, nc, nc2);
		    ft++;             // someone claims we are her sisters,
		    if (ft > 100)      
			return 0;     // we don't think so
		    break;            // in future we go on, mark it as unreliable
		}
	    }                         // while sis !=nc
	    cel[nc2].sis = vc;        // the other sis points to vc
	    cel[vc].dot = vc + 1;     // daughter normaly is the next vc
	}                             // while nc <= ct

	if (cel[vc - 1].dot != 0)
	    cel[vc].mot = vc - 1;     // mother normaly is de previous cel
	else
	{                             // aft an answer starts a new branch with a sis

	    cel[vc].mot = cel[cel[vc].sis].mot;   // mother is also mother of our sis
	    if (ver == 0)
		ver = vc + 2;
	}
	vc++;
	nc++;
    }
    fclose (fnn);
    if ((fnn = fopen (fnnn, "w")) == NULL)
    {
	printf("nnwdorm1.c: error opening file %s\n",fnnn);
	return 1;
    }

 //------------------------output the net------------------------------------//
    nc2 = vc - 1;                     // total number of cells now in this NN
    strcat (well, ", doozed");        // admin line of this NN
    fprintf (fnn, "%li %li %li %i %i %s\n", dat1, dat3, dat, hor, ver, well);   

    for (nc = 0; nc <= nc2; nc++)
	fprintf (fnn, "%i %i %i %i %i %i %i %i %i %i\n", cel[nc].ad, cel[nc].me,
		cel[nc].wei, cel[nc].bi, cel[nc].mot, cel[nc].sis, cel[nc].dot,
		cel[nc].nan, cel[nc].ans, cel[nc].mar);
    //------------------------------------ reached -----------------------------

    fclose (fnn);                     // that was the updated NN, doozed
    fclose (flog);
    return EXIT_SUCCESS;
}
