/***************************************************************************
                 nnwdorm2.c   -  this is a vast sleep
                 project      -  Nnw
                 version      -   .03
                 -------------------
    begin        : Tue Mar 21 2000
    copyright    : (C) 2001 by Ed van der Meulen
    email        : ameulen@users.sourceforge.net
****************************************************************************
****************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* Dorm2 is a serious function of sleeping. Not just slumbering, no not    *
 * only doozing but a good and deep sleep with dreams, for it is form of   *
 * another time perceiving. Dorm2 is a typical bottum up function. Awake   *
 * most drivers came from the outside of the brain. Asleep not good fitting*
 * details rumble and are now the drivers. The function of Dorm2 is        *
 * reorganizing the mid term memory. It catagorizes all info in groups.    *
 * Dorm2 doesn't use extraordinary statements. But Dorm2 was for us        *
 * relatively difficult to program.                                        *
 ***************************************************************************/
#include "nnw.h"

int nnwdorm2(char *fin,char *fnnn)
{
    int ct, hor, ver;
    long dat = 0, dat1, dat2, dat3;
    char name[] = "nnwdorm2", flogn[20], *q, well[256];
    FILE *flog, *fi, *fnn;

    struct ocelt                        // in this phase of sleep dorm2 uses extra 
    {                                   // cells in the short amd mid term memory
        int nr;                         // dorm2 groops by location
        int onr;                        // location determents ans and mar, therefore
        int ans;                        // ocelt reminds ans en mar, accessible by onc
        int mar;
        int pos;                        // the old position in the NN
    };
    int onc;                            // counter of cells , in the old numbering
    int nnc;                            // counter as onc, in the new numbering
    struct ocelt ocel[memmx];           // translation from old to new numbering
    unsigned fz;
    int cel1;                           // the 1st cel has a sister at the 1st branch
    int cant;                           // celnr of the next answer
    int sisi;                           // sister starting a branche ...
    int sonc;                           // old nr of sis ...

    fz = 0;                             // counter of faults
    ct = 0;				// number of cells in the net
    //---------------------------open files and read per admin and the data per cell--//
    if ((fi = fopen (fin, "r")) == NULL)// fin
    {
        printf("nnwdorm2.c: error opening file %s",fin);
        return 1;
    }

    strcpy (flogn, name);
    strcat (flogn, ".log");
    if ((flog = fopen (flogn, "w")) == NULL)      // in log-file
    {
        printf("nnwdorm2.c: error opening file %s\n",flogn);
        return 1;
    }
    fscanf (fi, "%li %li %li %i %i", &dat1, &dat2, &dat3, &hor, &ver);   //admin line of NN
    fgets (well, 255, fi);
    if ((q = strchr (well, '\n')) != NULL)
        *q = '\0';                      // remove trailling \n
    while (!feof (fi))
    {                                   // read all cels of NN, but per cell
        fscanf (fi, "%i %i %i %i %i %i %i %i %i %i", &cel[ct].ad, &cel[ct].me,
              &cel[ct].wei, &cel[ct].bi, &cel[ct].mot, &cel[ct].sis,
              &cel[ct].dot, &cel[ct].nan, &cel[ct].ans, &cel[ct].mar);
        ct++;
    }
    //-------------------------done reading the cells---------------------------------//
    ct -= 2;
    onc = 0;
    fclose (fi);
    /*-------------------------go through the net in this way-------------------------*
     * start with Alma amd go down straight to the first answer                       *
     * Alma(1) ----------------------answer(2), this is the first found down way and  *
     * so the first branch for copying                                                *
     * ********************************************************************************/
    cel[0].mot = 0;
    cel1 = 0;                           // this is the old posnr of a stop cel
    sisi = 0;                           // old posnr start of this branche, old sis
    onc = 0;                            // old posnr starts
    nnc = onc;
    do
    {                                   // branch down: `----,-------> :dot=0
        do
        {
            onc++;                      //-- look for cel with dot=0 --
            nnc += 1;
            if (nnc > ct)
                break;
            cel[onc].mot = onc - 1;
            cel[onc - 1].ans = 0;       // old answer can be mistaken
            ocel[onc].nr = nnc;         // ocel[].nr translates old celnrs into new
        }   while ((cel[onc].dot > onc) || (onc > ct));      
      
        // found cel and dot=0, don't come here again
        // or this cell connects the branch with a former branch = network
	/******************************************************************************
	 * now the answer cell has been triggered and an upstream goes to the first   *
	 * possibility to go down again, this occurs by the first side branch (3)     *
	 * closiest to the answer cell                                                *
	 * (1) -------------------------------\-----------(2)                         *
	 *                                   (3)\----------------  ----(4)            *
	 * after the start cell of a new branch has been found (3) the stream can go  *
	 * down again for the second, a third and so on alway new branch and in this  *
	 * sequence be copied                                                         *
	 * ****************************************************************************/                                  
        // the only extra work si to keep all the relationships so the pointers
	
        ocel[sisi].pos = onc;           // ocel.pos of a branch startcell saves her 
                                        // own answercel, the jump
        cant = onc;                     // cant holds the posnr of the anser of a branch 
                                        // for starting a next branche
        if (onc > ct)
            break;                      // there is no anwer cel beyond the rear:
        ocel[onc].ans = cel[onc].ans;   // turn answer + margin into, 
                                        // upper + lower bound
        ocel[onc].mar = cel[onc].mar;   // ocel holds ans and mar as value and 
                                        // margin
        cel[onc].ans = ocel[onc].nr;    // new nrs stipulate from en to, 
                                        // attainability
        ocel[nnc].onr = onc;            // ocel.onr turns new nrs into old
        cel[onc].mar = cel[onc].ans;    // with old numbers
        sonc = 0;
        do
        {                               // some branches back til a new division
            do
            {                           //-- searche back til first division
                if (sonc == 0)
                {
                    cel[onc].sis = ocel[onc].nr;// branche up `-<<---,--| ans: dot=0
                    sonc = 0;           // caming from below, sis is already sound
                }
                onc -= 1;               // searche back siscel
                cel[onc].ans = cel[onc + 1].ans;
                cel[onc].mar = cel[onc + 1].mar;
            }
            while (!((cel[onc].sis != onc) || (onc == 0)));
            if (onc == 0)
                break;                  // ans is up to date through the siscel
            do
            {
                sisi = cel[onc].sis;    //-- found cel with sis
                if (sisi > onc)
                {
                    cel[sisi].mot = cel[onc].mot;
                    onc = sisi;             // ---onc----<    --ans
                    nnc++;                  //    v
                    ocel[sisi].nr = nnc;    //    sisi----->>----,
                    ocel[cant].pos = sisi;  // ocel.pos of former answercel hold sisi
                    break;
                }                               //----- go on in the lower branch-->
                cel[sisi].sis = ocel[onc].nr;   // -<-sisi---- former branche
                cel[onc].sis = ocel[sisi].nr;   //    ^
                sonc = onc;                     //    onc-----<-----  back
                onc = sisi - 1;
                cel[onc].mar = cel[sisi].mar;
                cel[onc].ans = cel[sisi].ans;
                if ((cel[onc].mar < cel[sonc].mar) || (cel[onc].ans == 0))
                    cel[onc].mar = cel[sonc].mar;
                if ((cel[onc].ans > cel[sonc].ans) || (cel[onc].ans == 0))
                    cel[onc].ans = cel[sonc].ans;
            }
            while (cel[onc].sis != onc);
            if (onc == sisi)
                break;
        }
        while (onc != 0);
    }
    while (onc != 0);                   // till Alma
   
    onc++;                              //-- saving as in the long term memory --
    cel1 = 0;
    nnc = 0;
    if (strstr (well, "slept well") == 0)
        strcat (well, ", slept well");
    if ((fnn = fopen (fnnn, "w")) == NULL)
    {
        printf("nnwdorm2.c: error opening file %s\n",fnnn);
        return 1;
    }
    fprintf (fnn, "%li %li %li %i %i %s\n", dat1, dat3, dat, hor, ver, well);   
                                        // fresh admin line of NN
    do
    {
        sisi = cel1;                    // first of a branch
        cant = ocel[sisi].pos;          // last of that branch
        if (nnc > ct)
            break;
        cel1 = ocel[cant].pos;          // ocel of the last knows 1st of next branch
        for (onc = sisi; onc <= cant; onc++)
        {                        // print a branche
	                         // we found these nice and clear expressions
				 // by first giving all a unique name and then
				 // substituting these several times
            sonc = ocel[ocel[cel[onc].ans].onr].ans - ocel[ocel[cel[onc].ans].onr].mar;
                                        // sonc is the old sis nr, 
	    cel[onc].mar = ocel[ocel[cel[onc].mar].onr].ans - ocel[ocel[cel[onc].mar].onr].mar;
					// hanging here
	    printf("cel[onc].mar = %i\n", cel[onc].mar);

            cel[onc].ans = (cel[onc].mar + sonc) >> 1;   // turn upper+lowerboundarry into ans+margin
            cel[onc].mar = (cel[onc].mar - sonc) >> 1;
            cel[onc].mot = ocel[cel[onc].mot].nr;
            cel[onc].dot = ocel[cel[onc].dot].nr;

            // print a cel
            fprintf (fnn, "%i %i %i %i %i %i %i %i %i %i\n", cel[onc].ad,
                  cel[onc].me, cel[onc].wei, cel[onc].bi, cel[onc].mot,
                  cel[onc].sis, cel[onc].dot, cel[onc].nan, cel[onc].ans,
                  cel[onc].mar);
            nnc++;
        }
    }
    while ((nnc <= ct));
    if (nnc < ct)
        printf 
            ("Someting was: %i 'I must do: %i.... Badly slept... .. .\n", nnc, ct);
    //------------------------------------ reached -----------------------------
    fclose (fnn);
    fclose (flog);
    return EXIT_SUCCESS;
}
// has someone the guts to make dorm 2 a bit more logical?
