/***************************************************************************
      nngui.cc  -  Graphical user interface
      project   -  Nnw
      version   -   .03
      -------------------
     begin                : Thu Apr 13 2000
     copyright            : (C) 2001 by Ed van der Meulen
     email                : ameulen@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* example-start helloworld2 helloworld2.c */

#include <gtk/gtk.h>
#include <stdio.h>
#include <unistd.h>
#include "nnw.h"

int cleanup (GtkWidget * widget, gpointer data)
{
    int errc;
    if ((errc = unlink(def_nn)))
    {
	printf("nnwgui.c: unlink failed from cleanup() with errorcode %d\n",errc);
	return(1);
    }
    return 0;
}

int learn (GtkWidget * widget, gpointer data)
{
    int errc;
    if ((errc = nnwcv(def_snnslet,def_nnlet)))
    {
	printf("nnwgui.c: call to nnwcv() from learn() failed with errorcode %d\n",errc);
	return 1;
    }
    if ((errc = nnwshop(def_nnlet,def_nn)))
    {
	printf("nnwgui.c: call to nnwshop() from learn() failed with errorcode %d\n",errc);
	return 1;
    }
    return 0;
}

int dorm1 (GtkWidget * widget, gpointer data)
{
    int errc;
    if ((errc = nnwdorm1(def_nn,def_nn)))
    {
	printf("nnwgui.c: call to nnwdorm1() from dorm1() failed\n");
	return 1;
    }
    return 0;
}

int dorm2 (GtkWidget * widget, gpointer data)
{
    int errc;
    if ((errc = nnwdorm1(def_nn,def_nn)))
    {
	printf("nnwgui.c: call to nnwdorm1() from dorm2() failed\n");
	return 1;
    }
    if ((errc = nnwdorm2(def_nn,def_nn)))
    {
	printf("nnwgui.c: call to nnwdorm2() from dorm2() failed\n");
	return 1;
    }
    return 0;
}

int view (GtkWidget * widget, gpointer data)
{
    int errc;
    if ((errc = nnwview(def_nn)))
    {
	printf("nnwgui.c: call to nnwview() from view() failed\n");
	return 1;
    }
    return 0;
}


/* another callback */
void delete_event (GtkWidget * widget, GdkEvent * event, gpointer data)
{
    gtk_main_quit ();
}

int main (int argc, char *argv[])
{
    /* GtkWidget is the storage type for widgets */
    GtkWidget *window;
    GtkWidget *button;
    GtkWidget *box1;

    /* this is called in all GTK applications.  arguments are parsed from
     * the command line and are returned to the application. */
    gtk_init (&argc, &argv);

    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

    /* this is a new call, this just sets the title of our
     * new window to "Hello Buttons!" */
    gtk_window_set_title (GTK_WINDOW (window), "NNWgui version .03");

    /* Here we just set a handler for delete_event that immediately
     * exits GTK. */
    gtk_signal_connect (GTK_OBJECT (window), "delete_event",
	    GTK_SIGNAL_FUNC (delete_event), NULL);


    /* sets the border width of the window. */
    gtk_container_border_width (GTK_CONTAINER (window), 10);

    /* we create a box to pack widgets into.  this is described in detail
     * in the "packing" section below.  The box is not really visible, it
     * is just used as a tool to arrange widgets. */
    box1 = gtk_vbox_new (TRUE, 10);

    /* put the box into the main window. */
    gtk_container_add (GTK_CONTAINER (window), box1);

    /* creates a new button with the label "Button 1". */
    button = gtk_button_new_with_label ("Cleanup");

    /* Now when the button is clicked, we call the "callback" function
     * with a pointer to "button 1" as it's argument */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (cleanup), NULL);

    /* instead of gtk_container_add, we pack this button into the invisible
     * box, which has been packed into the window. */
    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* always remember this step, this tells GTK that our preparation for
     * this button is complete, and it can be displayed now. */
    gtk_widget_show (button);

    /* do these same steps again to create a second button */
    button = gtk_button_new_with_label ("Learn");

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (learn), NULL);

    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* The order in which we show the buttons is not really important, but I
     * recommend showing the window last, so it all pops up at once. */
    gtk_widget_show (button);

    /* do these same steps again to create a second button */
    button = gtk_button_new_with_label ("Dorm1");

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (dorm1), NULL);

    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* The order in which we show the buttons is not really important, but I
     * recommend showing the window last, so it all pops up at once. */
    gtk_widget_show (button);

    /* do these same steps again to create a second button */
    button = gtk_button_new_with_label ("Dorm2");

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (dorm2), NULL);

    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* The order in which we show the buttons is not really important, but I
     * recommend showing the window last, so it all pops up at once. */
    gtk_widget_show (button);

    /* do these same steps again to create a second button */
    button = gtk_button_new_with_label ("View");

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (view), NULL);

    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* The order in which we show the buttons is not really important, but I
     * recommend showing the window last, so it all pops up at once. */
    gtk_widget_show (button);

    /* do these same steps again to create a second button */
    button = gtk_button_new_with_label ("Quit");

    /* call the same callback function with a different argument,
     * passing a pointer to "button 2" instead. */
    gtk_signal_connect (GTK_OBJECT (button), "clicked",
	    GTK_SIGNAL_FUNC (delete_event), NULL);

    gtk_box_pack_start (GTK_BOX (box1), button, TRUE, TRUE, 0);

    /* The order in which we show the buttons is not really important, but I
     * recommend showing the window last, so it all pops up at once. */
    gtk_widget_show (button);

    gtk_widget_show (box1);

    gtk_widget_show (window);

    /* rest in gtk_main and wait for the fun to begin! */
    gtk_main ();

    return 0;
}
