/***************************************************************************
      nnwshop.c  -  shopping in the CELMEM store
      project     -  Nnw
      version     -   .03
      -------------------
     begin      : Wed Mar 15 2000
     copyright  : (C) 2001 by Ed van der Meulen
     email      : ameulen@users.sourceforge.net
 ******************************************************************************

 ******************************************************************************
 *                                                                            *
 *   This program is free software; you can redistribute it and/or modify     *
 *   it under the terms of the GNU General Public License as published by     *
 *   the Free Software Foundation; either version 2 of the License, or        *
 *   (at your option) any later version.                                      *
 *                                                                            *
 ******************************************************************************/

#include "nnw.h"

int nnwshop(char *fon, char *fnnn)
{
    int io[100];
    int hor, ver, ct = 0, tio, cio, bio, gct, lt;
    long dat = 0, dat1, dat2, dat3;
    FILE *flog, *fnn, *fi;
    char name[] = "nnwshop", flogn[20], *q, txt[256], well[256];

    if ((fi = fopen (fon, "r")) == NULL)
    {
	printf("nnwshop.c: error opening file %s\n",fon);
	return 1;
    }
    fscanf (fi, "%i %i", &hor, &ver);
    fgets (well, 255, fi);
    if ((q = strchr (well, '\n')) != NULL) *q = '\0';
    strcpy (flogn, name);
    strcat (flogn, ".log");
    if ((flog = fopen (flogn, "w")) == NULL)      // log-file
    {
	printf("nnwshop.c: error opening file %s\n",flogn);
	return 1;
    }
    //--------------------------NN exists or doesn't, not in the beginning
    if ((fnn = fopen(fnnn, "r")) == NULL)
    {                              // If NN doesn't exist make ALMA the first cell
	cel[0].ad = 0;             // all is new
	cel[0].me = 0;
	cel[0].wei = 127;
	cel[0].bi = 32767;
	cel[0].mot = 0;            // yuo can ask the nanny to work for you
	cel[0].sis = 0;            // nanny is the first of a groupe cels that
	cel[0].dot = 0;            // can perform special tasks coming back
	cel[0].nan = 0;            // to you with their answer
	cel[0].ans = 0;
	cel[0].mar = 32767;
	dat = 0;
	dat1 = 0;
	dat2 = 0;                  // there is no former mutation
	dat3 = 0;
	cp[1].ad = 0;              // np special genetic data
    }                              // fase of doozed=1, slept=2, other 0
    else
    {                              //--- NN exists, examin admin line who is it
	fscanf (fnn, "%li %li %li %i %i", &dat1, &dat2, &dat3, &hor, &ver);
	fgets (well, 255, fnn);
	if (strstr(well, "dooz")) {// if in demo H0 the met has doozed or slep it can't learn anymore
	    printf("after doozed or slept demo H0 can't learn anymore, admin = %s\n", well);
	    return 1;		   // this is a temporary solution
	}
	if ((q = strchr (well, '\n')) != NULL)
	    *q = '\0';
	if (strstr ("slept", well) != 0)
	    cp[1].ad = 2;          // NN has slept and propably doozed
	else if (strstr ("doozed", well) != 0)
	    cp[1].ad = 1;          // NN did not sleep after recent learning,
	while (!feof (fnn))
	{                          // but it did snooze             
	    fscanf (fnn, "%i %i %i %i %i %i %i %i %i %i", &cel[ct].ad,
		    &cel[ct].me, &cel[ct].wei, &cel[ct].bi, &cel[ct].mot,
		    &cel[ct].sis, &cel[ct].dot, &cel[ct].nan, &cel[ct].ans,
		    &cel[ct].mar);
	    ct++;                  // read the whole old NN
	}
	ct--;
    }

    //------ done --pre work---------------------------

    //----------------------------- update the old NN with new info ------------
    gct = ct;                      // number cels in NN at the beginning of the session
    while (fgets (txt, 255, fi))
    {
	if ((q = strchr (txt, '\n')) != NULL)
	    *q = '\0';
	q = strtok (txt, " ");
	if (q != NULL)
	{
	    io[0] = atoi(q);
	    tio = 0;               // read io-groupe (line) once and analyse it
	    q = txt;
	    while (q != NULL)
	    {
		tio++;
		q = strtok (NULL, " ");
		if (q != NULL)
		    io[tio] = atoi(q);
	    }
	}
	if (io[tio] < 0)
	{
	    cp[1].me = 1;          // cp.me remembers the aswer and margin
	    io[tio] = -io[tio];    // line of question/learn contains answer/margin
	    tio--;
	}                          // once per question or per session?
	else
	    cp[1].me = 0;          // answers without margin
	cio = io[tio - 1] + io[tio];
	bio = io[tio - 1] - io[tio];// into nnshop for 1 question or 1 learn line

	//-----------------------------------------------------------------------
	//--- above is the GG, the great generator of the market place ----------
	nnshop (flog, &ct, &tio, &bio, &cio, io);// proces 1 quest/learn
	//--- with this function GG goes into Celmem, the quarter of industries--

    }                              // next character, till the end of fi,
    fclose (fi);                   // input file exhausted, the end of learning
    //-----------------------------------------------------------------------

    //--------------------------------- write whole NN per cell -----------------
    tio = ct - gct;                //
    if (tio != 0)
    {
	lt = strlen (well) - well[0]; // CHANGED strstr() to strlen()... no more segfaults from this statement!

	if (lt <= 0)
	    strcat (well, ", in NN first learned");
	else
	    well[(lt + 23)] = '\0';
	if ((fnn = fopen (fnnn, "w")) == NULL)  // first the admin line of NN
	{
	    printf("nnwshop.c: error opening file %s\n",fnnn);
	    return 1;
	}
	printf("\nver = %i\n", ver);
	fprintf (fnn, "%li %li %li %i %i %s\n", dat1, dat3, dat, hor, ver, well);

	for (lt = 0; lt <= ct; lt++)
	    fprintf (fnn, " %i %i %i %i %i %i %i %i %i %i\n", cel[lt].ad,
		    cel[lt].me, cel[lt].wei, cel[lt].bi, cel[lt].mot,
		    cel[lt].sis, cel[lt].dot, cel[lt].nan, cel[lt].ans,
		    cel[lt].mar);
    }
    printf ("\n");
    fprintf (flog, "   %i cells added.\n", tio);
    printf ("%i cells added total.\n", tio);
    if (tio == 0)
	printf ("  Nothing learned.\n");

    //------------------------------ reached ------------------------------------

    //---------------------------------------------------------------------------
    fclose (fnn);
    fclose (flog);
    return EXIT_SUCCESS;
}                                  // end main

//--------------------------------- function nnshop ----------------------------
void nnshop (FILE *flog, int *ct, int *tio, int *bio, int *cio, int *io)
{
    int zeen;                      // first sister
    int nc = 0;                    // cel connter
    int ft;                        // fault
    unsigned short fnd;            // found ?
    int lt;                        // loopcounter etc
    int mama = 0;                  // mam

    for (lt = 0; lt < *tio; lt++)
    {                              // proces the groupe / line per value
	fnd = 0;                   // io-value does not yet fit
	if (*ct > 0)               // there is a cel beside ALMA
	{
	    if (cel[mama].dot > 0)
	    {
		nc = cel[mama].dot;// celcounter nc starts ar mam's daughter
		zeen = nc;         // first sis of mine that's me
		do                 // look for the value among the sisters
		{
		    /* If after sleeping the answer of io[tio] resides within min and max of ans 
		     * and mar, the situation looks sound, ans becomes sharper. In version .03 
		     * answers in the input have no margins. There is no answer given or there is. 
		     * No answer: io[*tio]=0
		     */
		    if (
			    ( (cp[1].me == 1) &&		       // answer does have a margin
			      ( (cel[nc].ans != 0) &&		       // i'm an answer cell
				( (*bio > cel[nc].ans - cel[nc].mar) ||// answer should under ceilling
				  (*cio < cel[nc].ans + cel[nc].mar)   // and above bottom
				)
			      )
			    ) || (cel[nc].me != io[lt])            // i don't match with input
		       )
			nc = cel[nc].sis;    // I become my sister, is she the wanted one?
		    else
		    {
			mama = nc;           // I myself have the io-value and become mam
			fnd = 1;
			if ((cel[nc].mar == 0) && (cel[nc].dot == 0))
			{
			    ft = cel[nc].ans >> 1;
			    printf (" recognized as: (%i) %c", ft, (char) ft);
			}                    // one claims she is our sister we think not
			break;
		    }
		}
		while (nc != zeen);          // I'm again my first me, value not fnd
	    }  // if cel[mama].dot > 0
	}
	if ((lt == *tio) && (io[lt] == 0))
	    fnd = 1;                    // no answer (0),
	if (!fnd)
	{
	    (*ct)++;                    // a new cel is arriving
	    if (cel[mama].dot == 0)
	    {
		cel[mama].dot = *ct;    // did mam not have a child, she gets one
		cel[mama].mar = 32767;  // in future platform independent
		cel[*ct].sis = *ct;
	    }
	    else
	    {
		cel[*ct].sis = cel[cel[mama].dot].sis;
		cel[cel[mama].dot].sis = *ct;   // add an extra sister, thats me
	    }
	    cel[*ct].ad = io[lt];       // give me my personal data
	    cel[*ct].me = cel[*ct].ad;
	    cel[*ct].wei = 9;
	    cel[*ct].bi = 0;
	    cel[*ct].mot = mama;
	    cel[*ct].dot = 0;
	    cel[*ct].nan = 0;
	    cel[*ct].ans = 0;
	    cel[*ct].mar = 0;
	    mama = *ct;
	}
	else
	    mama = nc;                // found, I the old cel becomes the new cel
    }                                 // for lt
    cel[mama].ans = cel[mama].ad << 1;// the answercel utself is our answer
    cel[mama].mar = 0;

    //------------------------------ line processed -----------------------------
    // report rest of row of generations till the mam without daughters=answer

    while (cel[mama].dot != 0)        // endcel of a branche si no endcel? then fault
    {
	fprintf (flog, "    %i %i", cel[mama].ad, cel[mama].bi);
	mama = cel[mama].dot;
    }
    fprintf (flog, "    %i %i: %c", cel[mama].ad, cel[mama].bi,
	    (char) (cel[mama].ad));
    return;
}   //end function nnshop
