/**************************************************************************
      nnwview.h -  used functions and types for nnwview
      project   -  Nnw
      versiom   -  .03
      -------------------
     begin                : Wed Mar 29 2000
     copyright            : (C) 2001 by Ed van der Meulen
     email                : ameulen@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

    
    // default size of window
#define scw 650
#define sch 500

    // rgb values of our blue...
#define blue_red 43
#define blue_green 36
#define blue_blue 227
    // rgb values for grey
#define grey_red 203
#define grey_green 203
#define grey_blue 203

    // width of one character in pixels
#define char_width 6
    // width of one cell (plus texts) in characters
#define cell_width 5
    // some constants...
/* if krap:  the distances around position numbers of cells posnr
 * ---------------------------- top of screen
 *          . -+
 *          .  |  top_spacing
 *          . -+
 *     ^    . -+  line_height (8)                                 -+
 *  posnr 1 .  |  * is center of the cell, all others are relative | posnr of
 *     v    .  |      around that position for that cell           | cell 1
 *  ###*### .  |  -+                                               |
 *          .  |   |  half_line_height (4)                         |
 *     |    .  |   |  -+                                           |
 *     |    . -+  -+  -+  under_spacing (-2)                       |
 *     |    . -+  spy (variable, here 1)                          -+
 *     |    . -|                                                  -+
 *     |    . -+                                                   |posnr of
 *     |    . -+  upper_spacing (-2)                               | cell 2
 *          .                                                      |
 *  ###*### . -+                                                   |
 *     ^    .  | under_margin                                      |
 *  posnr 2 .  |                                                   |
 * ---------. -+                                                  -+
 *          . -+
 *          .  | bottom_spacing
 *          . -+
 * --------------------------- bottom of screen
 *
 * if not krap it's nearly the same, but line_height is twice as high,
 * half_cell_height is the half of that, so the center is between two lines
 * (probably the last line of cell 1, or the first of cell 2
 */
#define line_height 16
#define upper_spacing -10
#define under_spacing -3
#define top_spacing (line_height << 1)
#define bottom_spacing (line_height << 1)
#define under_margin 4

